{% extends "base.html" %}

{% block title %}Dashboard{% endblock %}

{% block extra_styles %}
<link rel="stylesheet" href="{{ url_for('static', filename='styles/dashboard.css') }}">
{% endblock %}

{% block content %}
<div class="container mt-5">
    <!-- Chart Containers -->
    <div class="row">
        <div class="col-md-6 mb-4">
            <div class="chart-container">
                <canvas id="distributionChart"></canvas>
            </div>
        </div>
        <!-- Placeholder for the second chart -->
        <div class="col-md-6 mb-4">
            <div class="chart-container" style="position: relative; width:350px; height:350px;">
                <canvas id="errorTypeChart"></canvas>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-md-6 mb-4">
            <div class="chart-container" style="position: relative; width:350px; height:350px;">
                <canvas id="cleanAssignmentsChart"></canvas>
            </div>
        </div>
        <div class="col-md-6 mb-4">
            <div class="chart-container">
                <canvas id="errorComparisonChart"></canvas>
            </div>
        </div>
    </div>

    <!-- Include Chart.js library -->
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>

    <script>
        document.addEventListener('DOMContentLoaded', function () {
            // Data from Flask
            const names = {{ names|tojson }};
            const lines = {{ lines|tojson }};
            const ifElseStatements = {{ if_else_statements|tojson }};
            const whileLoops = {{ while_loops|tojson }};
            const vars = {{ vars|tojson }};
            const methods = {{ methods|tojson }};

            // Distribution Chart
            const distributionCtx = document.getElementById('distributionChart').getContext('2d');
            new Chart(distributionCtx, {
                type: 'line',
                data: {
                    labels: names, // This is still used for data alignment
                    datasets: [
                        {
                            label: 'Lines of Code',
                            data: lines,
                            backgroundColor: 'rgba(255, 99, 132, 0.2)',
                            borderColor: 'rgba(255, 99, 132, 1)',
                            borderWidth: 1,
                            fill: false
                        },
                        {
                            label: 'If/Else Statements',
                            data: ifElseStatements,
                            backgroundColor: 'rgba(54, 162, 235, 0.2)',
                            borderColor: 'rgba(54, 162, 235, 1)',
                            borderWidth: 1,
                            fill: false
                        },
                        {
                            label: 'While Loops',
                            data: whileLoops,
                            backgroundColor: 'rgba(75, 192, 192, 0.2)',
                            borderColor: 'rgba(75, 192, 192, 1)',
                            borderWidth: 1,
                            fill: false
                        },
                        {
                            label: 'Variables',
                            data: vars,
                            backgroundColor: 'rgba(153, 102, 255, 0.2)',
                            borderColor: 'rgba(153, 102, 255, 1)',
                            borderWidth: 1,
                            fill: false
                        },
                        {
                            label: 'Methods',
                            data: methods,
                            backgroundColor: 'rgba(255, 159, 64, 0.2)',
                            borderColor: 'rgba(255, 159, 64, 1)',
                            borderWidth: 1,
                            fill: false
                        }
                    ]
                },
                options: {
                    responsive: true,
                    plugins: {
                        legend: {
                            display: true
                        },
                        tooltip: {
                            callbacks: {
                                label: function (context) {
                                    return context.dataset.label + ': ' + context.raw;
                                }
                            }
                        },
                        title: {
                            display: true,
                            text: 'Distribution of Programming Concepts',
                            font: {
                                size: 18
                            }
                        }
                    },
                    scales: {
                        x: {
                            title: {
                                display: false,
                                text: 'Assignments'
                            },
                            ticks: {
                                display: false // Hide x-axis labels
                            }
                        },
                        y: {
                            title: {
                                display: true,
                                text: 'Count'
                            },
                            beginAtZero: true
                        }
                    }
                }
            });

            // Placeholder for additional charts
            // Initialize other charts if needed (secondChart, thirdChart, fourthChart)
            // Example:
            const ctx = document.getElementById('errorTypeChart').getContext('2d');
            new Chart(ctx, {
                type: 'pie',
                data: {
                    labels: {{ labels|tojson }},
                    datasets: [{
                        label: 'Error Distribution',
                        data: {{ values|tojson }},
                        backgroundColor: [
                            'rgba(255, 99, 132, 0.2)',  // Unused Variables
                            'rgba(54, 162, 235, 0.2)',  // Unused Methods
                            'rgba(255, 206, 86, 0.2)',  // Match If/Else
                            'rgba(75, 192, 192, 0.2)'   // Missing Brackets
                        ],
                        borderColor: [
                            'rgba(255, 99, 132, 1)',   // Unused Variables
                            'rgba(54, 162, 235, 1)',   // Unused Methods
                            'rgba(255, 206, 86, 1)',   // Match If/Else
                            'rgba(75, 192, 192, 1)'    // Missing Brackets
                        ],
                        borderWidth: 1
                    }]
                },
                options: {
                    responsive: true,
                    plugins: {
                        title: {
                            display: true,
                            text: 'Distribution of Programming Concept Errors', // Title for the chart
                            font: {
                                size: 18
                            }
                        },
                        tooltip: {
                            callbacks: {
                                label: function (context) {
                                    return context.label + ': ' + context.raw + ' assignments';
                                }
                            }
                        }
                    }
                }
            });

              // Pie Chart for Clean Assignments vs. Assignments with Errors
            const cleanAssignmentsCtx = document.getElementById('cleanAssignmentsChart').getContext('2d');
            new Chart(cleanAssignmentsCtx, {
                  type: 'pie',
                  data: {
                      labels: {{ clean_assignments_labels|tojson }},
                      datasets: [{
                          data: {{ clean_assignments_values|tojson }},
                          backgroundColor: ['rgba(75, 192, 192, 0.6)', 'rgba(255, 99, 132, 0.6)'],
                          borderColor: ['rgba(75, 192, 192, 1)', 'rgba(255, 99, 132, 1)'],
                          borderWidth: 1
                      }]
                  },
                  options: {
                      responsive: true,
                      plugins: {
                          legend: {
                              position: 'top'
                          },
                          title: {
                            display: true,
                            text: 'Clean code vs Code with errors', // Title for the chart
                            font: {
                                size: 18
                            }
                        },
                          tooltip: {
                              callbacks: {
                                  label: function (context) {
                                      let label = context.label || '';
                                      if (label) {
                                          label += ': ' + context.raw;
                                      }
                                      return label;
                                  }
                              }
                          }
                      }
                  }
                });

            
            
            const errorComparisonCtx = document.getElementById('errorComparisonChart').getContext('2d');
            new Chart(errorComparisonCtx, {
                    type: 'bar',
                    data: {
                        labels: [
                            'Module 2: Types',
                            'Module 3: Instruction Conditionnelle',
                            'Module 4: Instructions Itératives',
                            'Module 5: Collections',
                            'Module 6: Méthodes'
                        ],
                        datasets: [
                            {
                                label: 'Error Count',
                                data: [
                                    {{ categorize_error.module_2 }},
                                    {{ categorize_error.module_3 }},
                                    {{ categorize_error.module_4 }},
                                    {{ categorize_error.module_5 }},
                                    {{ categorize_error.module_6 }}
                                ],
                                backgroundColor: [
                    'rgba(255, 99, 132, 0.6)', // Module 2: Types (Red)
                    'rgba(255, 206, 86, 0.6)', // Module 3: Instruction Conditionnelle (Yellow)
                    'rgba(75, 192, 192, 0.6)', // Module 4: Instructions Itératives (Green)
                    'rgba(153, 102, 255, 0.6)', // Module 5: Collections (Blue)
                    'rgba(255, 159, 64, 0.6)'  // Module 6: Méthodes (Orange)
                ],
                borderColor: [
                    'rgba(255, 99, 132, 1)', // Module 2: Types (Red)
                    'rgba(255, 206, 86, 1)', // Module 3: Instruction Conditionnelle (Yellow)
                    'rgba(75, 192, 192, 1)', // Module 4: Instructions Itératives (Green)
                    'rgba(153, 102, 255, 1)', // Module 5: Collections (Blue)
                    'rgba(255, 159, 64, 1)'  // Module 6: Méthodes (Orange)
                ],
                                borderWidth: 1
                            }
                        ]
                    },
                    options: {
                        responsive: true,
                        plugins: {
                            legend: {
                                position: 'top'
                            },
                            tooltip: {
                                callbacks: {
                                    label: function (context) {
                                        return context.dataset.label + ': ' + context.raw;
                                    }
                                }
                            },
                            title: {
                                display: true,
                                text: 'Error Categorization by Module'
                            }
                        },
                        scales: {
                          
                            y: {
                                title: {
                                    display: true,
                                    text: 'Errors'
                                },
                                beginAtZero: true
                            }
                        }
                    }
                });
                
            });
    </script>
{% endblock %}
